Program CBM64; { Mixed (PAS & ASM) version 1 }

{$DEFINE AZERTY - (or QWERTY) }

uses
 VGA,C64ROM,KEYBOARD,IEC,D64,DATA,DIALOGS;

{$I KEYB.PAS}

{$L CBM64.OBJ}
Procedure Startup; external;
Procedure Emulate; external;

Function HexaB(b:byte):string;
 const
  hexa:array[0..$F] of char='0123456789ABCDEF';
 begin
  HexaB:=Hexa[b shr 4]+Hexa[b and $F];
 end;

Function HexaW(w:word):string;
 begin
  HexaW:=HexaB(hi(w))+HexaB(lo(w));
 end;


Procedure CPUJAM; far;
 var
  s:string;
 begin
  s:='CPU jammed at PC='+HexaW(PC)+' on opcode '+HexaB(opJAM)+#0;
  StatusBar(s);
  GetKey;
 end;

Procedure Pause; far;
 begin
  StatusBar('Press Enter to continue');
  GetKey;
 end;

Procedure Joy1Active; far;
 begin
  StatusBar('Using joystick #1');
  GetKey;
 end;

Procedure Joy2Active; far;
 begin
  StatusBar('Using joystick #2');
  GetKey;
 end;

Procedure StatusInfo; far;
 const
  top=80;
 var
  str:string;
  m:byte;
 begin
  Frame3D(25,top,310,078,clWhite,ClGrey,clBlue);
   OutTextXY(30,top+5,clGreen,'Status Info');
   OutTextXY(130,top+5,clGrey,'(During VBlank)');

   str:='Video Mode  : ';
   m:=((Mem[CIOSeg:53265] and $60) or (Mem[CIOSeg:53270]and$10)) shr 4;
   case m of
    0 : str:=str+'Standard Text';
    1 : str:=str+'MultiColor Text';
    2 : str:=str+'Standard Bitmap';
    3 : str:=str+'MultiCol.Bitmap';
    4 : str:=str+'Extended Text';
    5 : str:=str+'Ext. MC. Text';
    6 : str:=str+'Invalide Ext.';
    7 : str:=str+'Invalide Ext.MC';
   end;
   OutTextXY(30,top+15,clYellow,str);

   str:='Video Bank  : $'+HexaW(Bank);
   OutTextXY(30,top+25,clYellow,str);

   if m and 2=0 then begin
    str:='Video Ram   : $'+HexaW(VideoOfs);
    OutTextXY(30,top+35,clYellow,str);

    str:='CharGen     : ';
    if Seg(CharGen^)=RAMSeg then str:=str+'RAM' else
    if Seg(CharGen^)=ROMSeg then str:=str+'ROM' else str:=str+HexaW(Seg(CharGen^));

    str:=str+':'+HexaW(Ofs(CharGen^));

    OutTextXY(30,top+45,clYellow,str);


   end else begin
    str:='Bitmap Addr : $'+HexaW(BitmapOfs);
    OutTextXY(30,top+35,clYellow,str);
   end;

   str:='PC='+HexaW(PC); OutTextXY(270,top+5,clLightBlue,str);
   str:=' A='+HexaB(A); OutTextXY(270,top+15,clLightBlue,str);
   str:=' X='+HexaB(X); OutTextXY(270,top+25,clLightBlue,str);
   str:=' Y='+HexaB(Y); OutTextXY(270,top+35,clLightBlue,str);
   str:=' S=1'+HexaB(byte(S)); OutTextXY(270,top+45,clLightBlue,str);

   str:=' P='+HexaB(byte(P));  OutTextXY(270,top+55,clLightBlue,str);
   str:='nv0bdizc';
   if CFlag in P then str[8]:='C';
   if ZFlag in P then str[7]:='Z';
   if IFlag in P then str[6]:='I';
   if DFlag in P then str[5]:='D';
   if BFlag in P then str[4]:='B';
   if _Flag in P then str[3]:='1';
   if VFlag in P then str[2]:='V';
   if NFlag in P then str[1]:='N';
   OutTextXY(268,top+65,clLightBlue,str);

  GetKey;
 end;

var
 k1:byte absolute $40:$17;
           { bit 7 =1 INSert active
             bit 6 =1 Caps Lock active
             bit 5 =1 Num Lock active
             bit 4 =1 Scroll Lock active
             bit 3 =1 either Alt pressed
             bit 2 =1 either Ctrl pressed
             bit 1 =1 Left Shift pressed
             bit 0 =1 Right Shift pressed }
 k2:byte absolute $40:$18;
           { bit 7 =1 INSert pressed
             bit 6 =1 Caps Lock pressed
             bit 5 =1 Num Lock pressed
             bit 4 =1 Scroll Lock pressed
             bit 3 =1 Pause state active
             bit 2 =1 Sys Req pressed
             bit 1 =1 Left Alt pressed
             bit 0 =1 Left Ctrl pressed }
function AnyKey:boolean;
 begin
  AnyKey:=(k2>0)or((k1 and 15)>0)or(Port[$60]<128);
 end;

begin
{ Avoid CTRL(+F9) problem when runing this pgm under BP IDE }
 if (Port[$60]>0 { Windows } ) and AnyKey then begin
  writeln('Please, release all keys...');
  while AnyKey do;
 end;

{ RAM : 0000-FFFF }
{ ROM : 0000-1FFF - BASIC (A000-BFFF) }
{     : 2000-2FFF - CHIPS (D000-DFFF) }
{     : 3000-3FFF - CHARS (D000-DFFF) }
{     : 4000-5FFF - KERNL (E000-FFFF) }
 GetMem(RAM,$FFFF); RAMSeg:=Seg(RAM^);
 GetMem(ROM,$6000); ROMSeg:=Seg(ROM^)-$0A00;
                    CIOSeg:=Seg(ROM^)-$0D00+$0200;
                    VGASeg:=SegA000;
                    VGAOfs:=$0000;


 StartUp;

 Emulate;

 WriteLn('Exit at $',HexaW(PC));
 WriteLn('Total Cycles=',TotalCycles,' in ',Ticks,' seconds');
 WriteLn('Rate = ',Rate,'%');

end.