Unit Dialogs;

Interface

Function SelectFile(Title:String;Mask:string;Var FileName:string):boolean;
Procedure StatusBar(Text:String);

Const
 key_up=200;
 key_left=205;
 key_right=203;
 key_down=208;
 key_home=199;
 key_end=207;
 key_pgeup=201;
 key_pgedown=209;
 key_escape=27;
 key_return=13;

Implementation

uses
 DOS,VGA,Keyboard;

Var
 Path:string;

Type
 pFile=^TFile;
 TFile=record
  Name:string[15];
  Next:pFile;
  Prev:pFile;
 end;

Function SelectFile(Title:String;Mask:string;Var FileName:string):boolean;
 const
  top =40;
  width=150;
  left=(360-width) div 2;
  height=145;
 Var
  Files:pFile;

  AFile:pFile;
  LFile:pFile;

  ff:SearchRec;
  y :word;
  ly:word;
  k :byte;

  select:string;

  s:string;

 procedure DrawList;
  var
   AFile:pFile;
  begin
   Box(left+3,top+14,width-6,height-27,clWhite);
   ly:=Top+15;
   AFile:=LFile;
   while (AFile<>nil)and(ly<Top+Height-15) do begin
    OutTextXY(Left+4,ly,clBlack,AFile^.Name);
    inc(ly,9);
    AFile:=AFile^.Next;
   end;
  end;

 procedure AddItem(Item:string);
  var
   AFile:pFile;
   a,b:pFile;
  begin
   New(AFile);
   AFile^.Name:=Item+#0;
   Dec(AFile^.Name[0]);
   a:=Files;
   b:=nil;
   while (a<>nil)and(a^.Name<Item) do begin
    b:=a;
    a:=a^.Next;
   end;
   AFile^.Next:=a; if a<>nil then a^.Prev:=AFile;
   AFile^.Prev:=b; if b<>nil then b^.Next:=AFile else Files:=AFile;
   if Files=nil then Files:=AFile;
  end;

 begin
  SelectFile:=False;

  Frame3D(left,top,width,height,clWhite,clBlue,clLightBlue);
  Box(left+2,top+2,width-4,10,clBlue);
  OutTextXY(left+3,top+3,clWhite,Title);
  Frame3D(left+2,top+13,width-4,height-25,clLightGrey,clGrey,clWhite);
  OutTextXY(LefT+2,Top+Height-10,clBlue,'Enter / Esc');

  Select:=FileName;
  if Select='' then
   GetDir(0,Path)
  else begin
   Path:=FileName;
   y:=Length(Select);
   while Select[y]<>'\' do dec(y);
   Path[0]:=chr(y-1);
   Delete(Select,1,y);
  end;

  repeat

  Box(20,220,320,8,clLightBlue);
  OutTextXY(20,220,clBlue,Path);

  Files:=nil;
  LFile:=nil;

  FindFirst(Path+'\*.*',AnyFile,ff);
  while DOSError=0 do begin
   if (ff.Attr and Directory>0)and(ff.Name<>'.') then AddItem('/'+ff.Name);
   FindNext(ff);
  end;

  FindFirst(Path+'\*.'+Mask,AnyFile,ff);
  while DOSError=0 do begin
   AddItem(ff.Name);
   FindNext(ff);
  end;

  LFile:=Files;
  AFile:=LFile;
  y:=Top+15;

  if Select<>'' then begin
   While (AFile<>nil)and(AFile^.Name<>Select) do begin
    AFile:=AFile^.Next;
    if y<Top+15+12*9 then
     inc(y,9)
    else
     LFile:=LFile^.Next;
   end;
   if AFile=nil then begin
    LFile:=Files;
    AFile:=LFile;
    y:=Top+15;
   end;
  end;

  DrawList;

  repeat

   OutTextXY(Left+4,y,clGreen,AFile^.Name);

   k:=getkey;
   case k of
    key_up : begin
            if AFile^.Prev<>nil then begin
             OutTextXY(Left+4,y,clBlack,AFile^.Name);
             AFile:=AFile^.Prev;
             if y>Top+15 then
              dec(y,9)
             else begin
              LFile:=LFile^.Prev;
              DrawList;
             end;
            end;
           end;
    key_down : begin
            if AFile^.Next<>nil then begin
             OutTextXY(LefT+4,y,clBlack,AFile^.Name);
             AFile:=AFile^.Next;
             if y<Top+15+12*9 then
              inc(y,9)
             else begin
              LFile:=LFile^.Next;
              DrawList;
             end;
            end;
           end;
    key_left : if (Files^.Name[1]='/')and(Files^.Name[2]='.') then begin
                AFile:=Files;
                k:=key_return;
               end;
    key_right: if (AFile^.Name[1]='/')and(AFile^.Name[2]<>'.') then k:=key_return;
    key_home: if AFile<>Files then begin
               AFile:=Files;
               LFile:=Files;
               y:=Top+15;
               DrawList;
              end;
    key_end : if AFile^.Next<>nil then begin
               While AFile^.Next<>nil do begin
                AFile:=AFile^.Next;
                if y<Top+15+12*9 then inc(y,9) else LFile:=LFile^.Next;
               end;
               DrawList;
              end;
   end;

  until (k=key_escape)or(k=key_return);

  if k=key_return then begin
   if AFile^.Name[1]='/' then begin
    if AFile^.Name[2]='.' then begin
     Select:=Path;
     y:=Length(Select);
     while Select[y]<>'\' do dec(y); { remove last dir on "/.." }
     Path[0]:=chr(y-1);
     Delete(Select,1,y-1);
     Select[1]:='/';
    end else begin
     AFile^.Name[1]:='\'; { CD /DIR }
     Path:=Path+AFile^.Name; {dec(Path[0]); { bug fix :) }
    end;
   end else begin
    FileName:=Path+'\'+AFile^.Name;
    SelectFile:=True;
    k:=key_escape;
   end;
  end;

  LFile:=Files;
  While LFile<>nil do begin
   AFile:=LFile^.Next;
   Dispose(LFile);
   LFile:=AFile;
  end;

  until k=key_escape;

 end;

Procedure StatusBar(Text:String);
 begin
  Box(20,220,320,10,clRed);
  OutTextXY(21,221,clWhite,Text);
 end;

end.