Unit IEC;

Interface

{
 E156 : ; SAVE
        ...
        JSR FFD8->JMP F5DD ; SAVE RAM(ZPGE[A]..(XY)-1) ON DEV([BA])
                                  FILENAME at [BB,CC] Lenght=[B7]

}

{ LOAD "$",8
  ----------

   ATN Listen(8)  -> OpenDevice
   SEC 0,OPEN     -> Name:=''
   OUT "$"        -> Name:=Name+Chr(OUT)
   ATN Unlisten

   ATN Talk(8)
   SEC 0,DATA     -> LoadFile
   INP ...EOI     -> ReadByte -> ST_FILENOTFOUND (ST_READ_TIMEOUT)

   ATN Listen(8)
   SEC 0,CLOSE
   ATN Unlisten


  SAVE "TOTO",8
  -------------

   ATN Listen(8)  -> OpenDevice
   SEC 1,OPEN     -> Name:=''
   OUT "TOTO"     -> Name:=Name+Chr(OUT)
   ATN Unlisten

   ATN Listen(8)
   SEC 1,DATA     -> WriteFile
   OUT ........   -> WriteByte (ZPge[$95])
   ATN Unlisten

   ATN Listen(8)
   SEC 1,CLOSE
   ATN Unlisten
}
uses
 d64,fdos,DATA;

Procedure OutputATN;
Procedure OutputSEC;
Procedure Output;
Procedure Input;

Const
{ C64 status codes }
 ST_OK           = $00;	{ No error }
 ST_READ_TIMEOUT = $02;	{ Timeout on reading }
 ST_TIMEOUT      = $03; { Timeout }
 ST_EOF          = $40; { End of file }
 ST_NOTPRESENT   = $80; { Device not present }

 ST_FILENOTFOUND = ST_READ_TIMEOUT;

{ IEC command codes }
 ATN_LISTEN   = $20;
 ATN_UNLISTEN = $30;
 ATN_TALK     = $40;
 ATN_UNTALK   = $50;

{ IEC command codes }
 CMD_DATA =$60; { Data transfer }
 CMD_CLOSE=$E0; { Close Channel }
 CMD_OPEN =$F0; { Open Channel  }

Implementation

Const
 D1541=8;

Var
 ATN:byte;
 DEV:byte;
 SEC:byte;
 CMD:byte;

 Listener :integer;
 Talker   :integer;

 Name:string;

Function OpenDevice:byte;
 begin
  OpenDevice:=ST_NOTPRESENT;
  Case DEV of
   D1541: if D64.OpenDevice then OpenDevice:=ST_OK;
  end;
 end;

Function LoadFile:byte;
 begin
  LoadFile:=ST_NOTPRESENT;
  Case DEV of
   8:LoadFile:=D64.Load(SEC,Name);
  end;
 end;

Function SaveFile:byte;
 begin
  SaveFile:=ST_NOTPRESENT;
  Case DEV of
   8:SaveFile:=D64.Save(SEC,Name);
  end;
 end;

Function ReadByte:byte;
 begin
  Case DEV of
   8:ReadByte:=D64.ReadByte(SEC,A); { ST_FILENOTFOUND when D64.Load<>ST_OK }
  end;
 end;

Function WriteByte:byte;
 begin
  Case DEV of
   8: WriteByte:=D64.WriteByte(SEC,Mem[RAMSeg:$95],Mem[RAMSeg:$A3] AND $80);
  end;
 end;

{ Output one byte with ATN (Talk/Listen/Untalk/Unlisten) }
Procedure OutputATN; { ED23 }
 Var
  Result:Byte;
 begin
  Result:=ST_TIMEOUT;

  ATN:=A and $F0; {Listen/UnListen/Talk/UnTalk}
  DEV:=A and $0F; {8     /15      /8   /15    }

  Case ATN of
   ATN_LISTEN,ATN_TALK     : Result:=OpenDevice;
   ATN_UNLISTEN,ATN_UNTALK : Result:=ST_OK;
  end;

  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  if Result<>ST_OK then P:=P+[CFlag];
 end;

Procedure OutputSEC; { ED36 }
 Var
  Result:byte;
 begin
  Result:=ST_TIMEOUT;

  CMD:=A and $F0; { Listen:CMD_OPEN/CMD_CLOSE/CMD_DATA, Talk:CMD_DATA }
  SEC:=A and $0F; {        0/1      0/1       0/1            0        }

  Case ATN of

   ATN_LISTEN :
    Case CMD of
     CMD_OPEN : begin Name:=''; Result:=ST_OK; end;
     CMD_CLOSE: Result:=ST_OK;
     CMD_DATA : Result:=SaveFile;
    end;

   ATN_TALK :
    Case CMD of
     CMD_DATA : Result:=LoadFile;
    end;

  end;

  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  if Result<>ST_OK then P:=P+[CFlag];
 end;

Procedure Output; { ED40 - Output ZPge[$95] to Serial bus }
 Var
  Result:byte;
 begin
  Result:=ST_TIMEOUT;

  Case ATN of

   ATN_LISTEN:
    Case CMD of
     CMD_OPEN : begin
      Name:=Name+Chr(Mem[RAMSeg:$95]); { FILENAME }
      Result:=ST_OK;
     end;

     CMD_DATA : Result:=WriteByte { SAVE }
    end;

  end;

  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  if Result<>ST_OK then P:=P+[CFlag];
 end;

Procedure Input; { EE13 - A = ReadByte }
 Var
  Result:byte;
 begin

  A:=0;
  Result:=ST_TIMEOUT;

  Case ATN of

   ATN_TALK:
    Case CMD of
     CMD_DATA: Result:=ReadByte; { LOAD }
    end;

  end;


  Mem[RAMSeg:$90]:=Result;
  if Result<>ST_OK then P:=P+[CFlag];
 end;


end.